
 /* for the voids
    of the generalized two fixed centers problem
    from  norad elements to descart position and velosity */

 #include <math.h>

 #include "unfornor.h"
 #include "unforfun.h"  // simple function datan2

 void crona ( double  c[51] )   // output array of coefficients
 {

   double  fm,cj2,sig,a,e,s ;
   double  o,o2,o3,o4,o5,e2,e4 ;
   double  re,s2,rs,s4 ;
   double  p,p2,ps,p4 ;
   double  z2,pm,r1,r2,r3,r4 ;
   double  f0,f1,f2,b0,b1,b2 ;
   double  ac ;
   double  ax,ag,at ;
   double  ag1,ag2,an;
   double  ac0 ;
   double  ak1,ak2,aq0 ;
   double  ap0,af0 ;

   fm = c[1];
   cj2 = c[3];
   sig = c[4];
   a = c[8];
   e = c[9];
   s = c[10];                   // sinus(i)
   ac = sqrt(fabs(1.0e0-s*s));  // cosinus(i)
   if  ( c[7] < 0.0e0 )  ac = -ac ; // angle of inclination greater then 90
   o = 1.0e0;
   o2 = 2.e0;
   o3 = 3.e0;
   o4 = 0.25e0;
   o5 = 0.5e0;
   e2 = e*e;
   re = o-e2;
   e4 = e2*e2;
   s2 = s*s;
   rs = o-s2;
   s4 = s2*s2;
   p = cj2/(a*re);
   p2 = p*p;
   ps = p*sig;
   z2 = sig*sig;
   ax = e*(o+p2*re*(o-o2*s2+p2*(o3
           -16.e0*s2+14.e0*s4-o2*e2*rs*rs)));
   c[14] = ax;
   ag = -ps*(o-o2*s2-p2*(o3-12.e0*s2+10.e0*s4+e2*(o-o2*s4)));
   at = ps*s*(o-p2*(5.e0-6.e0*s2-e2*(o-o2*s2)));
   c[15] = ag;
   c[16] = at;
   ak1 = 0.125e0*p2*s2*(re+z2-4.e0*p2*re*rs);
   ak2 = 0.125e0*p2*e2*(s2-p2*(o-10.e0*s2+11.0e0*s4+e2*s4));
   c[26] = ak1;
   c[27] = ak2;
   pm = sqrt(fm*a*re);
   p2 = o5*p2;
   p4 = o5*p2*p2;
   ag1 = pm*(o+p2*(rs*(o3+e2)+z2*(6.e0-7.e0*s2))
             -p4*rs*(9.e0+11.0e0*s2+e2*(6.e0+34.e0*s2)+e4*(o+o3*s2)));
   ag2 = pm*(o-p2*(o3-4.e0*s2-e2)-p4*(9.e0-72.e0*s2
             +64.e0*s4+e2*(o2-40.e0*s2+48.e0*s4)+e4));
   an = ag1*(o+o2*ak2+9.e0*sqr(ak2))/(ag2*(o+o2*ak1+9.e0*sqr(ak1)));
   c[17] = ag1;
   c[18] = ag2;
   c[19] = an;
   ps = ps*s*ac;
   p2 = p*p;
   p4 = p2/16.0e0;
   c[20] = o2*ps*(o-p2*(4.e0-5.e0*s2+e2*s2));
   r1 = p2*ac;
   r2 = o2*p4;
   r3 = 4.0e0*r2;
   r4 = o4*r1*p4;
   ac0 = -r1*(o+o5*e2+p4*(24.e0-56.e0*s2
              -4.e0*e2*(o+16.e0*s2)-e4*(o2+o3*s2)));
   c[21] = ac0;
   c[22] = -o2*r1*e*(o+r2*(4.e0-28.e0*s2-e2*(6.e0+7.e0*s2)));
   c[23] = -o4*r1*e2*(o-r3*(11.0e0+e2*(o+s2)));
   c[24] = 16.e0*r4*e*e2*(o2-s2);
   c[25] = r4*e4*(o2+s2);
   aq0 = -o5*r1*(re+o3*z2-o2*p4*re*(30.e0-35.e0*s2+e2*(o2+o3*s2)));
   c[28] = aq0;
   c[29] = p2*ps*re;
   c[30] = 6.e0*r4*s2*re*re;
   f2 = o-r3*re*(4.e0-7.e0*s2)-p2*r2*re
        *(20.e0-136.e0*s2+113.e0*s4-e2*(8.e0+24.e0*s2-47.e0*s4));
   f1 = p2*re*(o2-o3*s2+r3*(o2-22.e0*s2+19.e0*s4
                -e2*s2*(10.e0-13.e0*s2)));
   f0 = o/(f1+f2);
   f0 = f0/sqrt(o-ax*ax);
   f0 = f0*re*re;
   b0 = r3*(-s2+r3*(6.e0-20.e0*s2+15.e0*s4-e2*s4));
   b1 = -p2*r3*s2*(o2-s2);
   b2 = o3*p2*r2*s4;
   ap0 = f0*(b0+b1+b2*(o+o5*ax*ax));
   c[32] = ap0;
   c[33] = ax*(b1+o2*b2)*f0;
   c[34] = o4*e2*b2*f0;
   f0 = p2*f0*ag2/ag1;
   af0 = o5*f0*s2*(o+o3*ak1);
   c[35] = af0;
   c[36] = -f0*s*(o2*ag-1.5e0*s*at);
   c[38] = -f0*s2*at/6.e0;
   c[37] = -f0*s2*(o4+ak1);
   c[39] = 0.125e0*f0*s2*ak1;
   c[40] = -ap0-an*af0;
   c[45] = an-o;
   c[42] = c[41]/(o-c[40]);
   c[43] = c[45]*c[42];
   c[46] = ac0+an*aq0;
   c[44] = c[42]*c[46];
   c[47] = ak1*(o+4.e0*ak1);
   c[48] = -0.75e0*ak1*ak1;
   c[49] = -an*ak2*(o+4.e0*ak2);
   c[50] = 0.75e0*an*ak2*ak2;
   c[23] = c[23]+aq0*c[49];
   c[30] = c[30]+aq0*c[47];
   c[34] = c[34]+af0*c[49];
   c[37] = c[37]+af0*c[47];

 }  // crona void


 void elemc ( double  ai ,       // inclination in degree
              double  ae ,       // eccentricity
              double  anob  ,    // mean motion in revolution per day
              double  c[51] )    // output : result array coefficients
 {
   int  j ;
   double  fm,rz,cj2,sig,a1,a2,a3,an0 ;
   double  s,asz,ac,ad,adz,f0,f1,f2,fc ;
   double  re,pe,p2,p4,ps,d2,rd,d4,rc,rr ;
   double  r1,f3,ab,dz2,rdz,dz4,rcz,rrz ;
   double  f4,f5,f6,f7,f8,f9,r3,r2 ;
 
   fm =  3.98600448000e+5;
   rz =  6.37813700000e+3;
   cj2 =  2.09728850857e+2;
   sig = -3.55889244242e-02;
   an0 = 2*M_PI*anob/86400.0; // mean motion to radian per second
   s = (M_PI/180.0)*ai; // from degree to radian
   asz = sin(s);
   ac = cos(s);
   ad = asz;
   adz = -asz;
   a1 = -exp(2.0e0/3.0e0*log(fm*an0));
   f0 = -fm/a1;
   ab = f0;
   fc = cj2/f0;
   re = 1.e0-sqr(ae);
   f1 = 2.e0-re;
   f2 = re*re;
   for (  j = 1 ;  j <= 4 ; j++ )
     {
       pe = cj2/(ab*re);
       p2 = pe*pe;
       p4 = p2*p2;
       ps = pe*sig;
       d2 = ad*ad;
       rd = 1.e0-d2;
       d4 = d2*d2;
       rc = 1.e0-2.e0*ps*ad-p2*d2*re;
       rr = 1.e0+2.e0*p2*d2*f1+p4*d4*f2;
       r1 = rc/rr;
       f3 = 1.e0-rd*r1;
       ab = f0*(1.e0-p2*re*rd*r1);
       dz2 = adz*adz;
       rdz = 1.e0-dz2;
       dz4 = dz2*dz2;
       rcz = 1.e0-2.e0*ps*adz-p2*dz2*re;
       rrz = 1.e0+2.e0*p2*dz2*f1+p4*dz4*f2;
       r2 = rcz/rrz;
       f4 = 1.e0-rdz*r2;
       f5 = f3+d2*adz*(fc*pe*(2.e0*ad+adz)+2.e0*ps);
       f6 =  f4+dz2*ad*(fc*pe*(2.e0*adz+ad)+2.e0*ps);
       f7 = sqrt(fabs((f5/f6)*(f4/f3)));
       f9 = r1/r2;
       f8 = 2.e0*f7*(1.e0+f7)*f9*asz;
       adz = (-1.e0+f9-f9*sqr((1.e0+f7)*asz)+(1.e0-f9*f7*f7)*dz2)/f8;
       ad = asz*(1.e0+f7)+f7*adz;
     }
   r3 = fm*ab*re*rd*(1.e0+2.e0*p2*f1+p4*f2)*r1;
   a3 = sqrt(fabs(r3));
   if  ( ac < 0.0e0 ) a3 = -a3; // inclination angle i > 90 degree
   a2 = -fm*ab*re*(1.e0+2.e0*p2*f1*rd*r1+p4*f2*rd*r1);
   c[8] = ab;
   c[9] = ae;
   c[10] = asz;
   c[11] = ac;
   c[5] = a1;
   c[6] = a2;
   c[7] = a3;
   c[12] = ad;
   c[13] = adz;
   c[1] = fm;
   c[2] = rz;
   c[3] = cj2;
   c[4] = sig;
   c[31] = -c[8]*c[9]*a1/fm;
   c[41] = an0;
   crona(c);
 }

 /*
   te    modified julian day
   ao    argument of perigei in degree
   au    the asc}ing node in degree
   ai    inclination in degree
   ae    eccentricity
   am    mean anomaly in degree
   anob  mean motion in revolution per day
 */

 void fromnoradtodescart
                 ( double  te ,   // input : elements epoch mjd
                   double  ao ,   // input : argument of perigei in degree
                   double  au ,   // input : the ascending node in degree
                   double  ai ,   // input : inclination in degree
                   double  ae ,   // input : eccentricity
                   double  am ,   // input : mean anomaly in degree
                   double  anob , // input : mean motion in revolution per day
                   double  dnob , // input : change of mean motion rev./day^2
                   double  tc ,      // input : current moment for position
                   double  xx[4] ,   // output : position vector in km
                   double  vv[4] )  // output : velosity vector in km
 {
   int  j ;
   double  c[51] ; // array for coefficients
   double  cj2,sig,z2,z0 ;
   double  udl,udg,udh,dift,ddl ;
   double  q1,q2,q3,ri,vs,vw,vt ;
   double  o,w,ol,a3,ab,asz,ac ;
   double  ax,ag,at,ag1,ag2,aq ;
   double  ac1,ac2,ac3,ac4 ;
   double  ak1,ak2,aq1,aq2 ;
   double  az,ap1,ap2 ;
   double  af1,af2,af3,af4,alam ;
   double  oh,amu,akf2,akf4 ;
   double  akp2,akp4,rxx,rx,pudl ;
   double  spp,cpp,spr,rb,sff,cff,sfr,ee,rt,bt ;
   double  sw,cw,su,cu ;
   double  r1,bs ;
   double  se,ce,ea,sp,cp,ep,de,sf,cf,ef ;
   double  bw,r2,r3,r4,r5,r6 ;

   elemc(ai,ae,anob,c); // result to array c[51]
   ddl = 2*M_PI*0.5*dnob*sqr(tc-te); /* +1/2 dn/dt (t-t_0)^2 radian */
   dift = 86400.0*(tc-te); /* in second */
   udl = (M_PI/180.0)*am+c[42]*dift+ddl;      /* to radian */
   udg = (M_PI/180.0)*ao+c[43]*dift+(M_PI/2);
   udh = (M_PI/180.0)*au+c[44]*dift-(M_PI/2);
   o = 1.0e0;
   w = 2.00000e0;
   ol = 0.0e0;
   cj2 = c[3];
   sig = c[4];
   a3 = c[7];
   ab = c[8];
   ae = c[9];
   asz = c[10];
   ac = c[11];
   ax = c[14];
   ag = c[15];
   at = c[16];
   ag1 = c[17];
   ag2 = c[18];
   aq = c[20];
   ac1 = c[22];
   ac2 = c[23];
   ac3 = c[24];
   ac4 = c[25];
   ak1 = c[26];
   ak2 = c[27];
   aq1 = c[29];
   aq2 = c[30];
   az = c[31];
   ap1 = c[33];
   ap2 = c[34];
   af1 = c[36];
   af2 = c[37];
   af3 = c[38];
   af4 = c[39];
   alam = c[40];
   oh =  c[45];
   amu = c[46];
   akf2 = c[47];
   akf4 = c[48];
   akp2 = c[49];
   akp4 = c[50];
   rxx = 1.e0-ax*ax;
   rx = sqrt(rxx);
   z2 = sqr(cj2);  // function from unforfun
   z0 = cj2*sig;
   sp = sin(udl);
   se = sp;
   cp = cos(udl);
   ce = cp;
   sf = ol;
   cf = o;
   ep = udl;
   ea = ep;
   pudl = ep-udl;
   spp = w*sp*cp;
   cpp = cp*cp-sp*sp;
   spr = w*spp*cpp;
   sff = w*sf*cf;
   j = 0;
   de = 1.0e0;
   while ( ( j < 15 ) && ( de > 1.0e-15 ) )
     {
       j = j+1;
       pudl = ep-udl;
       spp = w*sp*cp;
       cpp = cp*cp-sp*sp;
       spr = w*spp*cpp;
       sff = w*sf*cf;
       cff = cf*cf-sf*sf;
       sfr = w*sff*cff;
       ee = udl+az*se+alam*pudl-ap1*sp-ap2*spp
             -af1*sf+af2*sff+af3*(sf*cff+cf*sff)-af4*sfr;
       se = sin(ee);
       ce = cos(ee);
       rb = o/(o-ax*ce);
       sp = rx*rb*se;
       cp = (ce-ax)*rb;
       ep = ee+atan((sp*ce-cp*se)/(cp*ce+sp*se));
       ef = ep+udg+oh*pudl+akp2*spp+akp4*spr-akf2*sff+akf4*sfr;
       sf = sin(ef);
       cf = cos(ef);
       de = fabs(ea-ee);
       ea = ee;
     }
   bs = ab*(o-ae*ce);
   rt = o/(o-at*cf);
   bt = rt*(-asz*cf+ag);
   r1 = bs*bs+z2;
   r2 = o-bt*bt;
   r3 = sqrt(r1*r2);
   r4 = -ac*cf+aq;
   r6 = o/(r4*r4+sf*sf);
   r5 = sqrt(r6);
   bw = udh+1.570796326794896e0+amu*pudl+aq1*sf-aq2*sff;
   bw = bw+ac1*sp+ac2*spp+ac3*(sp*cpp+cp*spp)+ac4*spr;
   sw = r4*r5;
   cw = sf*r5;
   su = sin(bw);
   cu = cos(bw);
   xx[1] = r3*(cw*cu-sw*su);
   xx[2] = r3*(cw*su+sw*cu);
   xx[3] = z0+bs*bt;
   ri = o/(bs*bs+z2*bt*bt);
   r1 = o/r1;
   r2 = o/r2;
   q1 = sqrt(o-8*ak2*sp*sp);
   q2 = sqr(rx/(o+ax*cp));   // function unforfun.c
   q3 = ab*ae*ag2;
   vs = q3*ri*q2*sp*q1;
   q1 = sqrt(o-8*ak1*cf*cf);
   q2 = (asz-ag*at)*ag1;
   vt = q2*ri*rt*rt*sf*q1;
   vw = a3*r1*r2;
   r4 = bs*vs*r1-bt*vt*r2;
   vv[1] = xx[1]*r4-xx[2]*vw;
   vv[2] = xx[2]*r4+xx[1]*vw;
   vv[3] = bs*vt+vs*bt;
 }

 void alei ( double  c[51] )  /* output array */
 {
   int  j ;
   double  o,a1,a2,a3,fm,cj2,sig ;
   double  ab,ad,adz,re,fe,pa ;
   double  fa,rf,rt,rd,rdz,dz2 ;
   double  d2,pe,p1,p4,p2,rr,rc ;
   double  rrz,rcz,r,fd,ps,e2 ;
 
   o = 1.0e0;
   a1 = c[5];
   a2 = c[6];
   a3 = c[7];
   fm = c[1];
   cj2 = c[3];
   sig = c[4];
   ab = -fm/a1;
   fa = ab;
   fe = -a2/fm;
   re = fe/fa;
   pa = a3*a3;
   rd = -pa/a2;
   rdz = rd;
   fd = rd;
   pa = pa/fm;
   for (  j = 1 ;  j <= 5 ; j++ )
     {
       pe = cj2/(ab*re);
       p2 = pe*pe;
       ps = pe*sig;
       d2 = o-rd;
       ad = sqrt(fabs(d2));
       p1 = 2.e0*p2*(2.e0-re);
       p2 = p2*re;
       p4 = p2*p2;
       rr = o+p1*d2+p4*d2*d2;
       rc = o-2.e0*ps*ad-p2*d2;
       rr = rc/rr;
       rf = (o+p1+p4)*rr;
       rt = o+(rf-rr)*rd;
       ab = fa*(o-p2*rd*rr);
       re = fe/(ab*rt);
       rd = fd*rt/rf;
       dz2 = o-rdz;
       adz = -sqrt(fabs(dz2));
       rrz = o+p1*dz2+p4*dz2*dz2;
       rcz = o-2.e0*ps*adz-p2*dz2;
       rdz = pa*rrz/(ab*re*(o+p1+p4)*rcz);
     }
   e2 = o-re;
   c[8] = ab;
   c[9] = sqrt(fabs(e2));
   d2 = o-rd;
   c[12] = sqrt(fabs(d2));
   dz2 = o-rdz;
   c[13] = -sqrt(fabs(dz2));
   p2 = pe*pe*(3.e0-4.e0*d2+e2);
   c[10] = c[12]+ps*rd*(o-3.e0*ps*c[12]-p2);
   c[11] = sqrt(fabs(o-c[10]*c[10]));
   if  ( a3 < 0.0e0 )  c[11] = -c[11]; // angle of inclination i > 90 degree
   rf = o/fm;
   r = -a1*a1*a1;
   c[41] = sqrt(r)*rf;
   c[31] = -c[8]*c[9]*a1*rf;
 }

 /*
   t     modified julian day
   ao    argument of perigei in degree
   au    the asc}ing node in degree
   ai    inclination in degree
   ae    eccentricity
   am    mean anomaly in degree
   anob  mean motion in revolution per day
 */

 void fromdescarttonorad
                 ( double  t ,       // input : current moment for position
                   double  xx[4] ,   // input : position vector in km
                   double  vv[4] ,   // input : velosity vector in km
                   double  *tep ,    // output : elements epoch mjd
                   double  *ao ,     // output : argument of perigei in degree
                   double  *au ,     // output : the ascending node in degree
                   double  *ai ,     // output : inclination in degree
                   double  *ae ,     // output : eccentricity
                   double  *am ,     // output : mean anomaly in degree
                   double  *anob ,   // output : mean motion in rev. per day
                   double  *dnob )  // output : change of mean mot. rev./day^2
 {
   double  c[51] ;
   double  fm,rz,cj2,sig,z2,z0,aor,aur,amr ;
   double  z4,fi,vt,vs,a1,a2,a3,ab,asz,ac ;
   double  ax,ag,at,aq ;
   double  ac1,ac2,ac3,ac4,aq1,aq2 ;
   double  az,ap1,ap2,af1,af2,af3,af4,alam ;
   double  an0,oh,amu,akf2,akf4,akp2,akp4,pudl ;
   double  x1,x2,x3,v1,v2,v3,zx,u2,r1,f2,bs,bt ;
   double  se,ce,ea,sp,cp,ep,sf,cf,ef,spp,cpp,spr ;
   double  sff,cff,sfr,ao0,bw,au0,am0,r2,sr,cr ;

   fm =  3.98600448000e+5;
   rz =  6.37813700000e+3;
   cj2 =  2.09728850857e+2;
   sig = -3.55889244242e-02;
   z2 = sqr(cj2);  // function unforfun.c
   z0 = cj2*sig;
   x1 = xx[1];
   x2 = xx[2];
   x3 = xx[3]-z0;
   v1 = vv[1];
   v2 = vv[2];
   v3 = vv[3];
   zx = x3*x3;
   r2 = x1*x1+x2*x2+zx;
   u2 = v1*v1+v2*v2+v3*v3;
   r1 = x1*v1+x2*v2+x3*v3;
   f2 = 0.5e0*(r2-z2+sqrt(sqr(r2-z2)+4.0e0*z2*zx));
   bs = sqrt(f2);
   bt = x3/bs;
   z4 = z2*sqr(bt);
   fi = 2.0e0*fm/(f2+z4);
   vt = bs*v3-bt*r1;
   vs = bs*r1+z2*bt*v3;
   a1 = u2-fi*(bs-z0*bt);
   a3 = x1*v2-v1*x2;
   a2 = r1*r1-r2*u2+z2*v3*v3-fi*(bs*z4+z0*bt*f2);
   c[1] = fm;  c[2] = rz;  c[3] = cj2;  c[4] = sig;
   c[5] = a1;  c[6] = a2;  c[7] = a3;
   alei(c);
   crona(c);
   ab = c[8];
   asz = c[10];
   ac = c[11];
   ax = c[14];     ag = c[15];
   at = c[16];
   aq = c[20];
   ac1 = c[22];   ac2 = c[23];
   ac3 = c[24];   ac4 = c[25];
   aq1 = c[29];
   aq2 = c[30];    az = c[31];
   ap1 = c[33];
   ap2 = c[34];
   af1 = c[36];   af2 = c[37];
   af3 = c[38];   af4 = c[39];
   alam = c[40];  an0 = c[41];
   oh =  c[45];   amu = c[46];
   akf2 = c[47];  akf4 = c[48];
   akp2 = c[49];  akp4 = c[50];
   ce = (1.0e0-bs/ab)/c[9];
   se = sqrt(1.0e0-ce*ce);
   if  ( vs < 0.0e0 )  se = -se;
   ea = datan2(se,ce);          // function unforfun.c
   cp = (ce-ax)/(1.0e0-ax*ce);
   sp = sqrt(1.0e0-cp*cp);
   if  ( vs < 0.0e0 )  sp = -sp;
   ep = datan2(sp,cp);           // function unforfun.c
   sr = (bt-ag)/(asz-bt*at);
   cr = sqrt(fabs(1.0e0-sr*sr));
   if  ( vt < 0.0e0 )  cr = -cr;
   sf = cr;   cf = -sr;
   ef = datan2(sf,cf);           // function unforfun.c
   spp = 2.e0*sp*cp;     cpp = cp*cp-sp*sp;
   spr = 2.e0*spp*cpp;   sff = 2.e0*sf*cf;
   cff = cf*cf-sf*sf;    sfr = 2.e0*sff*cff;
   am0 = ea-az*se-alam*ep+ap1*sp+ap2*spp
          +af1*sf-af2*sff-af3*(sf*cff+cf*sff)+af4*sfr;
   amr = am0/(1-alam);
   pudl = ep-amr;
   ao0 = ef-ep-oh*pudl-akp2*spp-akp4*spr+akf2*sff-akf4*sfr;
   aor = ao0-(M_PI/2.0);
   r1 = -ac*cf+aq;
   bw = datan2(x2,x1)-datan2(r1,sf); // function unforfun.c
   au0 = bw-(M_PI/2.0)-amu*pudl
          -ac1*sp-ac2*spp-ac3*(spp*cp+cpp*sp)
          -ac4*spr-aq1*sf+aq2*sff;
   aur = au0+(M_PI/2.0);
   *am = (180.0/M_PI)*amr;                  // to degree
   while  ( *am < 0.0 )    *am = 360.0+*am; // in degree
   while  ( *am > 360.0 )  *am = *am-360.0;
   *ao = (180.0/M_PI)*aor;                  // to degree
   while  ( *ao < 0.0 )    *ao = 360.0+*ao;
   while  ( *ao > 360.0 )  *ao = *ao-360.0;
   *au = (180.0/M_PI)*aur;                  // to degree
   while  (  *au < 0.0  )  *au = 360.0+*au;
   while  ( *au > 360.0 )  *au = *au-360.0;
   *ai = (180.0/M_PI)*datan2(asz,ac);     // inclination to degree
   *ae = c[9];  // eccentricity
   *anob = (an0/(1-alam))*(0.5e0/M_PI)*8.64e4; // to rev. per day
   *dnob = 0.0; // default nullo
   *tep = t;    // epoch
 }

