
#include <math.h>

 /* prdegrangle is quite simple void
   to change a value for  angle  in degree
      to the civil form : sign degree minute second . */

 void prdegrangle ( double  angle ,     // input  : value angle in degree 
                    char   *anglesign , // output : "+" positive "-" negative
                    int    *intdegree , // output : degree
                    int    *intmin ,    // output : minute of arc
                    double *anglesec )  // output : second of arc
 {
    double  z , p , q , r , s ;  // temporary variables

    if  ( angle < 0 ) *anglesign = '-' ;  // negative angle
                 else *anglesign = '+' ;  // positive angle

    z = fabs(angle) ;       // always positive
    p = floor(z);           // float for degree

    r = 60.0*(z-p);         // minute without degree*/
    q = floor(r) ;          // float for minute of arc

    s = 60.0*(r-q);         // float for second of arc*/

    if  ( s > 59.999999e0 ) // to prevent strange case
      {
        s = 0.0 ;           // second to nullo
        q = q+1.0;          // but minute to increase
      }
    if  ( q > 59.999999e0 ) // to prevent the same
      {
        q = 0.0 ;           // minute to nullo
        p = p+1.0;          // but degree to increase
      }

    *intdegree = (int)p ;
    *intmin    = (int)q ;
    *anglesec  = s;
 }

 /* prhourangle is quite simple void
    to change a value for  angle  in degree
      to the civil form : sign hour minute second . */

 void prhourangle ( double  angle ,     // input  : value angle in degree 
                    int    *inthour , // output : hour
                    int    *intmin ,    // output : minute of time
                    double *anglesec )  // output : second of time
 { 
    double  z , p , q , r , s ;  // temporary variables 

    z = fabs(angle)/15.0 ;  // always positive to from degree hour
    p = floor(z);           // float for hour

    r = 60.0*(z-p) ;        // minute without hour
    q = floor(r) ;          // float for minute of time

    s = 60.0*(r-q) ;        // float for second of rime

    if  ( s > 59.999999e0 ) // to prevent strange case
      {
        s = 0.0 ;           // second to nullo
        q = q+1.0;          // but minute to increase
      }
    if  ( q > 59.999999e0 ) // to prevent the same
      {
        q = 0.0 ;           // minute to nullo
        p = p+1.0;          // but hour to increase
      } 

    *inthour   = (int)p ;
    *intmin    = (int)q ;
    *anglesec  = s;
 }
